(* ===================================================================

   VCG for test-suite, represented as a functor

=================================================================== *)

local 

open Parse HolKernel boolLib
open L0_emb_basic
open Test_emb_mldata Test_emb_basic
open Logic_gen

fun id x = x
val mk_T = Term `T`

in

functor build_TEVCG (L : Logic) =
   struct

   local

   structure stdVCG = build_VCG(L)

   
   fun VCG i post pre = stdVCG.VCG i post pre id

   val alg = { ftest = 
                  let 
                  fun rtest _ n i path 
                      = 
                      ( stdVCG.VCs 
                          := 
                          ( path ^ "." ^ n
                          , VCG (buildINSTRtree i) mk_T mk_T ) 
                          :: 
                          (!stdVCG.VCs)
                      )
                  in
                  rtest end

             , fsuite =
                  let
                  fun rsuite _ n rs path
                      =
                      ( List.map (fn r => r (path ^ "." ^ n)) rs
                      ; () )
                  in
                  rsuite end
              }

   in

   val VCs = stdVCG.VCs

   fun reduce preprocess_CONV test 
          = 
          ( stdVCG.VCs := []
          ; (  fold_TEST alg  
             o buildTEST        
             o expand_whitebox (QCONV preprocess_CONV)
             o rand
             o concl
               (* inserting QCONV due to Kan-3 update *)
             o QCONV preprocess_CONV ) 
               test "root" )

   fun red test = reduce ALL_CONV test 

   fun status () = stdVCG.status ()

   fun conclude () = stdVCG.conclude ()

   val verify1 = stdVCG.verify1

   val verify  = stdVCG.verify

   val autoverify = stdVCG.autoverify
                     
   end (* of inner local *)
   end (* of struct *)

end